import json
import boto3
import random 
import os



dyclient = boto3.client('dynamodb')



def dy_put(TableName,Item):
    response = dyclient.put_item(TableName=TableName,Item=Item)
    return response
    
def dy_updateItem(TableName,Key,Item):
    response = dyclient.update_item(TableName=TableName,Key=Key,AttributeUpdates=Item)
    return response  
    
def maketbfunction(_tabids):
    _ret ="<script>\n$(document).ready( function () {\n"
    for tid in _tabids:
        _ret += f"$('#{tid}').DataTable();\n"
    _ret += "} );\n</script>\n"
    return _ret
    
def maketbfunctions(_tabids):
    _ret ="<script>\n$(document).ready( function () {\n"
    _ret += f"$('#{_tabids}').DataTable();\n"
    _ret += "} );\n</script>\n"
    return _ret 
    
def getstyle(title):
 
    style = """ <style type="text/css">
    #customers {
      font-family: "Trebuchet MS", Arial, Helvetica, sans-serif;
      font-size: 12px;
      border-collapse: collapse;
      width: 55%;
    }
    #customers td, #customers th {
      border: 1px solid #ddd;
      padding: 8px;
      text-align: left;
    
    }
    #customers tr:nth-child(even){background-color: #f2f2f2;}
    
    #customers tr:hover {background-color: #ddd;}
    
    #customers th {
      padding-top: 12px;
      padding-bottom: 12px;
      font-family: "Trebuchet MS", Arial, Helvetica, sans-serif;
      font-size: 18px;
      text-align: left;
      background-color: white;
      color: black;
    }</style>
    <meta name="viewport3" content="width=800,initial-scale=1,user-scalable=yes"> 
    <script type="text/javascript" language="javascript" src="__apiurl__?action=wwwsvr&s3key=src/js/jquery-3.5.1.js"></script>
    <script type="text/javascript" language="javascript" src="__apiurl__?action=wwwsvr&s3key=src/js/jquery.dataTables.min.js"></script>
    <script type="text/javascript" charset="utf8"        src="__apiurl__?action=wwwsvr&s3key=src/js/jquery.dataTables.min.js"></script>
    <script type="text/javascript" charset="utf8"        src="__apiurl__?action=wwwsvr&s3key=src/js/jquery.dataTables.js"></script>
    <link rel="stylesheet" type="text/css"              href="__apiurl__?action=wwwsvr&s3key=src/css/jquery.dataTables.css">
    <link rel="stylesheet" type="text/css"              href="__apiurl__?action=wwwsvr&s3key=src/css/jquery.dataTables.min.css"> 
    """
    style = style.replace('__apiurl__',os.environ['apiurl'] )
    return style

def dy_scan(TableName):
   
    #tScanFilter={"LIC_Name": {"AttributeValueList": [ {"S":"Oracle"} ],"ComparisonOperator": "EQ"}}
    #sresults = table.scan(FilterExpression=Attr('LIC_Name').eq(event['LIC_Name']))
    sresults=dyclient.scan(  TableName=TableName)
    _rand = random.randint(10, 24200)
    tbid =f'tbid{_rand}' 
 

    _style = getstyle('hello')

   
    _th='<thead><tr>'
    _br=''
    _det=''
    xcon=1
    for t in sresults['Items']:
        _cp =len(t)
        lrow='<tr>'
        #_th='<thead><th colspan=%s>Provisioned products</th></tr><tr>' % _cp
        for l in t:
            if xcon == 1:
                _th += '<th align=left>%s</th>' %  l 
                print(json.dumps(l))

            lrow += '<td>%s</td>' % t[l]['S']
        lrow +='</tr>\n'
        _th += '</thead>'
        _det += lrow
        if xcon == 1:

                print(json.dumps(sresults['Items']))
                print(_th)
        xcon = xcon + 1
        
    tbscripts = maketbfunctions(tbid)
    
 
    _ret  = f"<html lang='en'><head> {_style}{tbscripts}</head>\n\n<body><table id='{tbid}' class='display'>{_th}<tbody>\n\n{_det}</tbody></table></body><hr>\n\n"
    
    
    
    return  _ret
     


def lambda_handler(event, context):
    
    TableName = os.environ['TableName'] 
    _html = dy_scan(TableName)
    
    return {
        "headers": {
                        'Content-Type': 'text/html',
                    },
        'statusCode': 200,
        'body': _html
    }
