import json
import boto3
import os

dyclient = boto3.client('dynamodb')

def dy_getitem(TableName,Key):
    _ret= 'no'
    response = dyclient.get_item(TableName=TableName,Key=Key)
    if 'Item' in response:
        _ret= 'yes'
    return _ret
    
            

def dy_put(TableName,Item):
    response = dyclient.put_item(TableName=TableName,Item=Item)
    return response
    
def dy_updateItem(TableName,Key,Item):
    response = dyclient.update_item(TableName=TableName,Key=Key,AttributeUpdates=Item)
    return response    
    
def db_addevent(dbevent):
    TableName = os.environ['TableName'] 
    sourceIPAddress      = dbevent['detail']['sourceIPAddress'] 
    awsRegion            = dbevent['detail']['awsRegion'] 
    userArn    = dbevent['detail']['userIdentity']['arn'] 
    accountId  = dbevent['detail']['userIdentity']['accountId'] 
    provisionedProductId = dbevent['detail']['responseElements']['recordDetail']['provisionedProductId']
    productName          = dbevent['detail']['responseElements']['recordDetail']['productName']
    productId            = dbevent['detail']['responseElements']['recordDetail']['productId']
    createdTime          = dbevent['detail']['responseElements']['recordDetail']['createdTime']
    recordType             = dbevent['detail']['responseElements']['recordDetail']['recordType']
    status                = dbevent['detail']['responseElements']['recordDetail']['status']
    provisionedProductName = dbevent['detail']['responseElements']['recordDetail']['provisionedProductName']
    pitem = {"provisionedProductId":{"S":provisionedProductId},
             "userArn":{"S":userArn},
             "awsRegion":{"S":awsRegion},
             "createdTime":{"S":createdTime},
             "sourceIPAddress":{"S":sourceIPAddress},
             "accountId":{"S":accountId},
             "productName":{"S":productName},
             "productId":{"S":productId},
             "provisionedProductName":{"S":provisionedProductName},
             "recordType":{"S":recordType},
             "status":{"S":status},
             "terminationTime":{"S":""}}
    
    ret= dy_put(TableName,pitem)
    
def db_updateevent(dbevent):
    TableName = os.environ['TableName'] 
    try:
        status                = dbevent['detail']['responseElements']['recordDetail']['status']
        recordType             = dbevent['detail']['responseElements']['recordDetail']['recordType']
        AttributeUpdates={
            "terminationTime":{"Action":"PUT","Value":{"S":dbevent['detail']['eventTime']}},
            "status":{"Action":"PUT","Value":{"S":status}},
            "recordType":{"Action":"PUT","Value":{"S":recordType}}
        }
        Key = {"provisionedProductId":{"S":dbevent['detail']['responseElements']['recordDetail']['provisionedProductId']}}
        dy_updateItem(TableName,Key,AttributeUpdates)
    except Exception as e:
        print (e)
 
    
    
def lambda_handler(event, context):
    
    ret= 'helloWorld'
    TableName = os.environ['TableName'] 
    dbevent = json.loads(event['body'])
     
    print( json.dumps(dbevent ))
    if dbevent['detail']['eventName'] == "ProvisionProduct":
        db_addevent(dbevent)

    if dbevent['detail']['eventName'] == "TerminateProvisionedProduct":
        provisionedProductId = dbevent['detail']['responseElements']['recordDetail']['provisionedProductId']
        Key= {"provisionedProductId":{"S":provisionedProductId}}
        _ret = dy_getitem(TableName,Key)
        dbevent['detail']['responseElements']['recordDetail']['status']= 'TERMINATED'
        if _ret == 'yes':
            db_updateevent(dbevent)
        else:
            db_addevent(dbevent)
         
 
    return {
        'statusCode': 200,
        'body': ret
    }
